package com.tzld.piaoquan.recommend.server.framework.recaller;

import com.tzld.piaoquan.recommend.server.framework.common.User;
import com.tzld.piaoquan.recommend.server.framework.candidiate.Candidate;
import com.tzld.piaoquan.recommend.server.gen.recommend.RecommendRequest;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public abstract class AbstractFilter<T> {
    protected final static Logger LOGGER = LoggerFactory.getLogger(AbstractFilter.class);
    protected final FilterConfigInfo filterConfigInfo;
    protected final RecommendRequest requestContext;
    protected final User user;
    protected final int requestIndex;

    public AbstractFilter(FilterConfigInfo filterConfigInfo,
                          RecommendRequest requestContext,
                          User user,
                          Integer requestIndex) {

        this.filterConfigInfo = filterConfigInfo;
        this.requestContext = requestContext;
        this.user = user;
        this.requestIndex = requestIndex;
    }

    public FilterConfigInfo getFilterConfigInfo() {
        return filterConfigInfo;
    }

    public abstract boolean predicate(Candidate candidate, T t);
}
